# Class VulkanPhysicalDeviceProperties.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanPhysicalDeviceProperties.Builder

Enclosing class:
  `VulkanPhysicalDeviceProperties`

public static final class VulkanPhysicalDeviceProperties.Builder extends Object
Builds instances of type `VulkanPhysicalDeviceProperties`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanPhysicalDeviceProperties`
  `build()`
  Builds a new `VulkanPhysicalDeviceProperties`.
  `final VulkanPhysicalDeviceProperties.Builder`
  `from(VulkanPhysicalDevicePropertiesType instance)`
  Fill a builder with attribute values from the provided `VulkanPhysicalDevicePropertiesType` instance.
  `final VulkanPhysicalDeviceProperties.Builder`
  `setApiVersion(VulkanVersion apiVersion)`
  Initializes the value for the `apiVersion` attribute.
  `final VulkanPhysicalDeviceProperties.Builder`
  `setDriverVersion(VulkanVersion driverVersion)`
  Initializes the value for the `driverVersion` attribute.
  `final VulkanPhysicalDeviceProperties.Builder`
  `setId(int id)`
  Initializes the value for the `id` attribute.
  `final VulkanPhysicalDeviceProperties.Builder`
  `setName(String name)`
  Initializes the value for the `name` attribute.
  `final VulkanPhysicalDeviceProperties.Builder`
  `setType(VulkanPhysicalDevicePropertiesType.Type type)`
  Initializes the value for the `type` attribute.
  `final VulkanPhysicalDeviceProperties.Builder`
  `setVendorId(int vendorId)`
  Initializes the value for the `vendorId` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanPhysicalDeviceProperties.Builder from(VulkanPhysicalDevicePropertiesType instance)
    Fill a builder with attribute values from the provided `VulkanPhysicalDevicePropertiesType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setName

    public final VulkanPhysicalDeviceProperties.Builder setName(String name)
    Initializes the value for the `name` attribute.
    Parameters:
      `name` - The value for name
    Returns:
      `this` builder for use in a chained invocation

  - ### setType

    public final VulkanPhysicalDeviceProperties.Builder setType(VulkanPhysicalDevicePropertiesType.Type type)
    Initializes the value for the `type` attribute.
    Parameters:
      `type` - The value for type
    Returns:
      `this` builder for use in a chained invocation

  - ### setId

    public final VulkanPhysicalDeviceProperties.Builder setId(int id)
    Initializes the value for the `id` attribute.
    Parameters:
      `id` - The value for id
    Returns:
      `this` builder for use in a chained invocation

  - ### setVendorId

    public final VulkanPhysicalDeviceProperties.Builder setVendorId(int vendorId)
    Initializes the value for the `vendorId` attribute.
    Parameters:
      `vendorId` - The value for vendorId
    Returns:
      `this` builder for use in a chained invocation

  - ### setApiVersion

    public final VulkanPhysicalDeviceProperties.Builder setApiVersion(VulkanVersion apiVersion)
    Initializes the value for the `apiVersion` attribute.
    Parameters:
      `apiVersion` - The value for apiVersion
    Returns:
      `this` builder for use in a chained invocation

  - ### setDriverVersion

    public final VulkanPhysicalDeviceProperties.Builder setDriverVersion(VulkanVersion driverVersion)
    Initializes the value for the `driverVersion` attribute.
    Parameters:
      `driverVersion` - The value for driverVersion
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanPhysicalDeviceProperties build()
    Builds a new `VulkanPhysicalDeviceProperties`.
    Returns:
      An immutable instance of VulkanPhysicalDeviceProperties
    Throws:
      `IllegalStateException` - if any required attributes are missing